## linux-wifi-hotspot-3.5.1.tar.gz

=== Makefile ===
all:
	mkdir -p build
	@echo "Run 'sudo make install' for installation."
	@echo "Run 'sudo make uninstall' for uninstallation."
	cd src && $(MAKE)

install:
	@echo "Installing..."
	cd src && $(MAKE) install

uninstall:
	@echo "Uninstalling..."
	cd src && $(MAKE) uninstall

clean-old:
	cd src && $(MAKE) clean-old

.PHONY: clean

clean:
	cd src && $(MAKE) clean

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(wihotspot-gui)

include(FindPkgConfig)
pkg_check_modules(GTK gtk+-3.0 REQUIRED)
pkg_check_modules(X11 x11 REQUIRED)
include_directories(${GTK_INCLUDE_DIRS})
include_directories(${X11_INCLUDE_DIRS})

set(CMAKE_C_STANDARD 99)
set (CMAKE_CXX_STANDARD 11)

add_executable(wihotspot-gui ui/main.c ui/h_prop.c ui/h_prop.h ui/ui.c ui/ui.h ui/read_config.cpp ui/read_config.h ui/util.c ui/util.h)

target_link_libraries(${PROJECT_NAME} ${GTK_LIBRARIES} ${X11_LIBRARIES})

include_directories(/usr/include)

set (source "${CMAKE_SOURCE_DIR}/ui/glade")
set (destination "${CMAKE_CURRENT_BINARY_DIR}/glade")

add_custom_command(
        TARGET ${PROJECT_NAME} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E create_symlink ${source} ${destination}
        DEPENDS ${destination}
        COMMENT "symbolic link resources folder from ${source} => ${destination}"
)

set (appdir "/usr/share")
set (appbin "/usr/bin")

add_custom_target(install_build

        COMMAND mkdir -p $ENV{DESTDIR}${appdir}/${PROJECT_NAME}
        COMMAND mkdir -p $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/glade
        COMMAND install -Dm755 ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME} $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/${PROJECT_NAME}
        COMMAND install -Dm755 ${CMAKE_CURRENT_BINARY_DIR}/glade/* $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/glade/
        COMMAND ln -rs $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/${PROJECT_NAME} $ENV{DESTDIR}${appbin}/${PROJECT_NAME}

        COMMAND install -Dm644 ${CMAKE_SOURCE_DIR}/desktop/hotspot.png $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/hotspot.png
        COMMAND install -Dm644 ${CMAKE_SOURCE_DIR}/desktop/wifihotspot.desktop $ENV{DESTDIR}${appdir}/${PROJECT_NAME}/${PROJECT_NAME}.desktop
        COMMAND install -Dm644 ${CMAKE_SOURCE_DIR}/desktop/wifihotspot.desktop $ENV{DESTDIR}${appdir}/applications/${PROJECT_NAME}.desktop
        DEPENDS ${PROJECT_NAME}
        COMMENT Installing files...

        COMMENT Remove old files if exist
        COMMAND rm -rf $ENV{DESTDIR}${appdir}/wihotspot
        COMMAND rm -f $ENV{DESTDIR}${appdir}/applications/wihotspot.desktop
        )

add_custom_target(uninstall_build
        COMMAND rm -rf $ENV{DESTDIR}${appdir}/${PROJECT_NAME}
        COMMAND rm -f $ENV{DESTDIR}${appbin}/${PROJECT_NAME}
        COMMAND rm -f $ENV{DESTDIR}${appdir}/applications/${PROJECT_NAME}.desktop
        COMMAND rm -rf $ENV{DESTDIR}${appdir}/${PROJECT_NAME}
        COMMENT Unstalling files...

        COMMENT Remove old files if exist
        COMMAND rm -rf $ENV{DESTDIR}${appdir}/wihotspot
        COMMAND rm -f $ENV{DESTDIR}${appdir}/applications/wihotspot.desktop
        )

=== src/Makefile ===
CC=gcc
PKGCONFIG = $(shell which pkg-config)

CFLAGS=`pkg-config --cflags gtk+-3.0`
LIBS=`pkg-config --libs gtk+-3.0 --libs x11` -lstdc++

APP_NAME="wihotspot"
APP_GUI_BINARY="wihotspot-gui"

PREFIX=/usr
BINDIR=$(PREFIX)/bin
APP_DIR=$(PREFIX)/share/$(APP_NAME)

ODIR=../build

GLIB_COMPILE_RESOURCES = $(shell $(PKGCONFIG) --variable=glib_compile_resources gio-2.0)

BUILT_SRC = resources.c

_OBJ = main.o ui.o h_prop.o util.o read_config.o $(BUILT_SRC:.c=.o)
OBJ = $(patsubst %,$(ODIR)/%,$(_OBJ))

# Determine this makefile's path.
# Be sure to place this BEFORE `include` directives, if any.
THIS_FILE := $(lastword $(MAKEFILE_LIST))

.PHONY: clean

all: resources.c

resources.c: ui/glade/wifih.gresource.xml ui/glade/wifih.ui
	$(GLIB_COMPILE_RESOURCES) ui/glade/wifih.gresource.xml --target=ui/$@ --sourcedir=ui/glade --generate-source
	@$(MAKE) -f $(THIS_FILE) wihotspot-gui
	
$(ODIR)/%.o: ui/%.c
	$(CC) -c -o $@ $< $(CFLAGS)

$(ODIR)/%.o: ui/%.cpp
	g++ -c -o $@ $<

wihotspot-gui: $(OBJ)
	$(CC) -o $(ODIR)/$@ $^ $(CFLAGS) $(LIBS)

install: $(ODIR)/wihotspot-gui
	mkdir -p $(DESTDIR)$(APP_DIR)
	install -Dm644 desktop/hotspot.png $(DESTDIR)$(APP_DIR)/hotspot.png
	install -Dm644 desktop/wifihotspot.desktop $(DESTDIR)$(APP_DIR)/$(APP_NAME).desktop
	install -Dm644 desktop/wifihotspot.desktop $(DESTDIR)$(PREFIX)/share/applications/$(APP_NAME).desktop
	install -Dm755 $(ODIR)/wihotspot-gui $(DESTDIR)$(BINDIR)/$(APP_GUI_BINARY)
	cd scripts && $(MAKE) install

uninstall:
	rm -rf $(DESTDIR)$(APP_DIR)
	rm -f $(DESTDIR)$(PREFIX)/share/applications/$(APP_NAME).desktop
	rm -f $(DESTDIR)$(BINDIR)/$(APP_GUI_BINARY)
	cd scripts && $(MAKE) uninstall

clean-old:
	rm -rf $(DESTDIR)/usr/share/wihotspot_gui
	rm -rf $(DESTDIR)/usr/share/wihotspot
	rm -f $(DESTDIR)/usr/bin/wihotspot_gui
	rm -f $(DESTDIR)/usr/bin/wihotspot

clean:
	rm -f $(ODIR)/*.o
	rm -f ui/$(BUILT_SRC)
	rm -f $(ODIR)/wihotspot-gui

=== src/scripts/Makefile ===
PREFIX=/usr
MANDIR=$(PREFIX)/share/man
BINDIR=$(PREFIX)/bin

all:
	@echo "Run 'make install' for installation."
	@echo "Run 'make uninstall' for uninstallation."

install:
	install -CDm755 create_ap $(DESTDIR)$(BINDIR)/create_ap
	install -CDm644 create_ap.conf $(DESTDIR)/etc/create_ap.conf
	[ ! -d $(DESTDIR)/lib/systemd/system ] || install -CDm644 create_ap.service $(DESTDIR)/lib/systemd/system/create_ap.service
	install -CDm644 bash_completion $(DESTDIR)$(PREFIX)/share/bash-completion/completions/create_ap
	install -CDm644 README.md $(DESTDIR)$(PREFIX)/share/doc/create_ap/README.md
	install -CDm755 wihotspot $(DESTDIR)$(BINDIR)/wihotspot

uninstall:
	rm -f $(DESTDIR)$(BINDIR)/create_ap
	rm -f $(DESTDIR)/etc/create_ap.conf
	[ ! -f $(DESTDIR)/lib/systemd/system/create_ap.service ] || rm -f $(DESTDIR)/lib/systemd/system/create_ap.service
	rm -f $(DESTDIR)$(PREFIX)/share/bash-completion/completions/create_ap
	rm -f $(DESTDIR)$(PREFIX)/share/doc/create_ap/README.md
	rm -f /etc/sudoers.d/create_ap	#	For older versions
	rm -f $(DESTDIR)$(BINDIR)/wihotspot

=== debian/changelog ===
linux-wifi-hotspot (3.5.1) UNRELEASED; urgency=low

  * Initial release.

 -- Scott Hardin <snhardin@users.noreply.github.com>  Wed, 21 Oct 2020 19:21:49 -0700

=== debian/control ===
Source: linux-wifi-hotspot
Section: devel
Priority: optional
Maintainer: Lakindu Akash <lakinduakash@users.noreply.github.com>
Build-Depends: debhelper (>=11~), pkg-config, libgtk-3-dev
Standards-Version: 4.1.4
Homepage: https://github.com/lakinduakash/linux-wifi-hotspot

Package: linux-wifi-hotspot
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, hostapd (>=2.0), iw (>= 5.4),iproute2 (>=5.0), util-linux (>=2.3), procps(>=3.3)
Description: GUI tool for creating virtual hotspots using the same wi-fi card that is already connected to an access point.
